PROGRAM PKTiny;

{============================================================================}
{                                                                            }
{   Copyright (c) 1992-95 by VGA-Software GmbH, Thomas Mnkemeier,           }
{                 Alte Amalienstr. 32, D-26135 Oldenburg, Germany.           }
{                                                                            }
{   This is no public domain, nor freeware or something similar.             }
{   Usage of this software requires my explicit permission.                  }
{   It is prohibited to give this software to somebody else.                 }
{   All rights are retained by the author of this software.                  }
{                                                                            }
{   The term "usage" above includes the following:                           }
{    - Using this software for own developments, including shareware         }
{      and commercial software.  The author's name must be mentioned         }
{      in the documentation of the respective software.                      }
{    - Modifying this software, but this copyright/license notice            }
{      MUST BE included in all copies UNCHANGED.                             }
{                                                                            }
{   All product names mentioned in this software are trademarks or           }
{   registered trademarks of their respective owners.                        }
{============================================================================}

{$M $4000,0,$8000}
{$A+,S-,F+,R-,I-,B-,V-,N-,X+,O-,G+}

USES DOS,Crt;

CONST HeaderSize=512;                  {soviel Mll kommt dazu !}
      ModOffset=$257;                  {Manipulation gegen VSAFE Fehlalarm}
      Optionen:STRING='/F /K /Mb "Program was modified and will not run.\n"';

PROCEDURE SelfModifier; ASSEMBLER;
ASM
  push ds
  push cs
  pop ds                               {Datenseg ist Codeseg}

  mov ax,$FFF0
  mov es,ax
  mov bl,es:$000E
  cmp bl,$FD
  jb @weiter

  @abgang:
  mov ah,$9                            {Stringausgabe ...}
  mov dx,Offset(@No286Messi)+$100
  int 21h
  pop ds
  mov ax,$4cFF                         {Abgang, Exitcode $FF}
  int 21h
  db $E9

  @weiter:
  cli
  push bp
  mov bp,sp
  lea ax,@goback                       {Weiter-Sprung-Adresse auf den Stack !}
  add ax,$100
  push ax
  add sp,2
  xor bx,bx
  mov word ptr[bx+0],$dde9             {Opcodes fr "jmp" und "hlt"}
  mov word ptr[bx+2],$f401
  mov word ptr[bx+ModOffset],$08b9     {VSafe-Fehlalarm: Vorher gucken was da stehen soll !}
  mov bx,[BP-2]
  jmp bx
  db $EA                               {Nebelbombe}
  @goback:
  sti

  xor bx,bx
  mov ax,$0E0D                         {Ausgabe TTY-Mode, =CR}
  int 10h
  mov ah,3
  int 10h
  xor dh,dh                            {dl ist null wenn keiner abfngt !}
  pop bp
  pop ds
  jmp dx                               {bei dl=0 gehts so wies soll}

  @No286Messi:
  db "This program runs only on i80286 and above.",10,"$"
END;

VAR OLD_29H:POINTER;
    Zeichen:CHAR;                      {Holds Charactor to Write}
PROCEDURE Patch1; INTERRUPT;
BEGIN
  Write(Zeichen);
END;
PROCEDURE Patch2; ASSEMBLER;
ASM
  push ds
  push ax
  mov ax,seg Zeichen
  mov ds,ax
  pop ax
  mov Zeichen,al
  pop ds
  jmp Patch1
END;

VAR Datei:FILE;
    EinzelWord:WORD;
    Tinyprog:PathStr;
    McAfeeProg:PathStr;
    ProcessFile:PathStr;
    NewHeaderFile:PathStr;
    Kommandozeile:STRING;
    Buffer:ARRAY [0..Headersize] OF BYTE;

PROCEDURE HelpScreen;
BEGIN
  TextMode(Co80);
  DirectVideo:=true;
  WriteLn('                         ');
  WriteLn('                  ');
  WriteLn('                      ');
  WriteLn('                        ');
  WriteLn(' ');
  WriteLn('                                           V1.62 ');
  WriteLn;
  IF ParamCount=0 THEN BEGIN
    WriteLn('Purpose  of this  nice tool is to generate  packed EXE-files  with the popular');
    WriteLn('TINYPROG-packer  that  will  have   an   authentic  PKLITE-header  to  confuse');
    WriteLn('some  of  the  well-known  unpackers  like  XOPEN, TRON or  UNP a  little bit.');
    WriteLn('The output-file contains a CPU-detection,  so your  program  may use 286-code.');
    WriteLn('An anti-virus-checksum will be appended using the famous SCAN by McAfee.');
    WriteLn;
    WriteLn('For  this  reason it is necessary  that  you have "PKLITE.EXE", "TINYPROG.EXE"');
    WriteLn('and "SCAN.EXE" in your path. PKTINY will either call them or read from them.');
    WriteLn;
    WriteLn('You may freely use,  copy and distribute this program, provided  that  no  fee');
    WriteLn('is charged for such use,  copying or distribution,  and it is distributed only');
    WriteLn('in its  original unmodified state.  PKTINY is  provided as is without warranty');
    WriteLn('of any kind,  express or implied,  including  but not  limited to  the implied');
    WriteLn('warranties   of  merchantability  and   fitness  for   a  particular  purpose.');
    Halt(0);
  END;
END;

FUNCTION PathOnly(FileName:STRING):STRING;
VAR Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
BEGIN
  FSplit(FileName,Dir,Name,Ext);
  PathOnly:=Dir;
END;
FUNCTION BaseNameOnly(FileName:STRING):STRING;
VAR Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
BEGIN
   FSplit(FileName,Dir,Name,Ext);
   BaseNameOnly:=Name;
END;
FUNCTION NameOnly(FileName:STRING):STRING;
VAR Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
BEGIN
   FSplit(FileName,Dir,Name,Ext);
   NameOnly:=Name+Ext;
END;

FUNCTION Str0(xn,l:WORD):STRING;
VAR xs:STRING;
    i:BYTE;
BEGIN
  STR(xn:l,xs);
  FOR i:=1 TO l DO
    IF xs[i]=' '
      THEN xs[i]:='0';
  Str0:=xs;
END;

FUNCTION Exists(Filename:STRING):BOOLEAN;
VAR SuchDummy:SearchRec;
BEGIN
  FindFirst(Filename,ReadOnly+Archive,SuchDummy);
  Exists:=(DOSError=0);
END;

PROCEDURE AbortMsg(Zeile:STRING);
BEGIN
  WriteLn(Zeile,', aborted.');
  Halt(1);
END;


BEGIN
  HelpScreen;
  Processfile:=ParamStr(1);
  IF POS('.',Processfile)=0
    THEN Processfile:=Processfile+'.EXE';
  Processfile:=FExpand(Processfile);
  WriteLn(' Processing file : ',Processfile);
  IF NOT(Exists(Processfile))
    THEN AbortMsg('File not found');
  TinyProg:=FExpand(FSearch('TINYPROG.EXE',GetEnv('PATH')));
  IF NameOnly(TinyProg)=''
    THEN AbortMsg('Program TINYPROG.EXE not found in path');
  WriteLn(' Tinyprog used   : ',TinyProg);
  NewHeaderFile:=FExpand(FSearch('PKLITE.EXE',GetEnv('PATH')));
  IF NameOnly(NewHeaderFile)=''
    THEN AbortMsg('Program PKLITE.EXE not found in path');
  WriteLn(' Header is from  : ',NewHeaderFile);
  McAfeeProg:=FExpand(FSearch('SCAN.EXE',GetEnv('PATH')));
  IF NameOnly(McAfeeProg)=''
    THEN AbortMsg('Program SCAN.EXE not found in path');
  WriteLn(' Anti-Virus-CRC  : ',McAfeeProg);
  WriteLn;
  {Jetzt wird TNYPROG aufgerufen, er soll aber etwas Platz lassen !}
  Kommandozeile:=Processfile+' '+Optionen+' /Ub 0 '+STR0(Headersize-36,3);
  SwapVectors;
  Exec(Tinyprog,Kommandozeile);
  SwapVectors;
  GotoXY(WhereX,WhereY-1);
  ClrEOL;
  WriteLn(' Errorlevel returned was #'+STR0(DOSError,3)+'.');
  IF DOSError<>0 THEN Halt(DOSError);
  Processfile:=PathOnly(Processfile)+BaseNameOnly(Processfile)+'.EXE';
  ASSIGN(Datei,NewHeaderFile);         {original PKLITE-Header aus PKLITE selbst}
  FileMode:=0;
  RESET(Datei,1);
  BlockRead(Datei,Buffer,HeaderSize);  {kommt in den Buffer fr mich}
  CLOSE(Datei);
  WriteLn(' PKLITE-Header loaded to buffer.');
  ASSIGN(Datei,ProcessFile);
  FileMode:=0;
  RESET(Datei,1);
  BlockRead(Datei,Buffer,28);          {Header der Originaldatei berlagern}
  CLOSE(Datei);
  Buffer[$14]:=LO($0100);              {EXE-Header IP neu setzen, wie PKLITE}
  Buffer[$15]:=HI($0100);
  Move(Mem[Seg(SelfModifier):Ofs(SelfModifier)],Buffer[$0100+32],144);
  FileMode:=2;
  RESET(Datei,1);
  BlockWrite(Datei,Buffer,HeaderSize);
  Seek(Datei,ModOffset+$20);
  BlockWrite(Datei,OLD_29H,2);
  WriteLn(' ',Headersize,' bytes patched, terminated.');
  CLOSE(Datei);
  GetIntVec($29,OLD_29H);
  SwapVectors;
  SetIntVec($29,@Patch2);
  Window(1,WhereY,80,WhereY);
  Exec(McAfeeProg,Processfile+' /AV /NOMEM');
  SetIntVec($29,OLD_29h);
  SwapVectors;
  IF DOSExitCode<>0
    THEN Write(' McAfee returned error #',DOSExitCode,'.')
    ELSE Write(' Appended validation data to file.');
  GotoXY(1,24);
END.
